/* Hintergrund-Kommandointerpreter fr Kommunikation ber UART */

#include "StdTypes.h"
#include "STM32F103all.h"
#include "config.h"
#include "conv.h"
#include "events.h"
#include "startup.h"
#include "systick.h"
#include "gio.h"
#include "cmd.h"
#include "holtek.h"
#include "vim878.h"
#include "testpins.h"
#include "ir.h"

char   Kommandozeile[80];
char*  Cpt;
char*  von;
char*  bis;



void ErrorStatus(word wo)
{ CRLF_Out (wo);
  String_Out(Manifest, wo);
  CRLF_Out (wo);
  if (!Errors) return;

  String_Out("Restart nach ", wo);
  if (Errors & (1<<0))  String_Out("Warmstart ", wo);
  if (Errors & (1<<1))  String_Out("reserved. ", wo);
  if (Errors & (1<<2))  String_Out("HardFault ", wo);
  if (Errors & (1<<3))  String_Out("MemMgrErr ", wo);
  if (Errors & (1<<4))  String_Out("BusFault ", wo);
  if (Errors & (1<<5))  String_Out("UsageFault ", wo);
  if (Errors & (1<<6))  String_Out("wrong SVC ", wo);
  if (Errors & (1<<7))  String_Out("DebugMoni ", wo);
  if (Errors & (1<<8))  String_Out("PendSV ", wo);
  if (Errors & (1<<9))  String_Out("SysTick ", wo);
  if (Errors & (1<<10)) String_Out("NMI ", wo);
  if (Errors & (1<<11)) String_Out("WeakINT ", wo);
  if (Errors > 0xFFF) HexL_Out(Errors, wo);
  CRLF_Out (wo);
}


/* Display Memory */

void DoDisplay (word wo)
{ char* ivon;
  char* ibis;
  char* von2;
  dword L;
  word  i;
  char  c;

  L = 255;
  if (*Cpt)
  { { von = (char*) Hex_In(&Cpt);
      L = Hex_In(&Cpt);
      if (!L) L = 255;
      bis = von + L;
    }
  }

  ivon = (char*) von;
  ibis = (char*) bis;

  while((long) ibis >= (long) ivon)
  {  CRLF_Out(wo);
     HexL_Out((long) ivon, wo);
     von2 = ivon;
     Char_Out(':', wo);
     i = 16;
     while(i)
     { --i;
       Char_Out(' ', wo);
       HexB_Out(*ivon++, wo);
     }
     Char_Out(' ', wo);
     i = 16;
     while(i)
     { --i;
       c = *von2++;
       if ((c<' ')||(c>126)) c = ' ';
       Char_Out(c, wo);
     }
  }
  von = (char*) ivon;
  bis = (char*) ivon + L;
  CRLF_Out(wo);
}


/* Gertestatus ausgeben */
void DoStatus(word wo)
{ String_Out("Gertestatus ", wo);
  ErrorStatus(wo);
}

word Buchstaben[128];
int  abuch;
int  aseg;

void anguck (void)
{ int i, j;

  HT_Fill(0);
  i = abuch-7;
  if (i<0) i = 0;
  j = 0;

  while (j<8) HT_Ram[j++] = Buchstaben[i++];
  HT_Transfer();
}

void blinzel (void)
{ word w;

  w = Buchstaben[abuch];
  Buchstaben[abuch] = w ^ (1<<aseg);
  anguck();
  Warte_ms(300);
  Buchstaben[abuch] = w;
  anguck();
}


void DoCommand (char* Pzeile, word wo)
{ char  c;
  int   i;
  long  L;

  Cpt = Pzeile;

  if (match("D",&Cpt))     { DoDisplay(wo); return;}
  if (match("G?",&Cpt))    { StdIO = wo; DoStatus(wo);  return;}

  /* hier ist Platz fr weitere Kommandos */

  if (match("ERASE",&Cpt)) { i = 0;
                             while(i<128)
                             { Buchstaben[i] = HT_Segments(i); ++i; }
                             aseg = 0;
                             i = 127;
                             while ((i>=0)&&(Buchstaben[i]==0)) i--;
                             abuch = i;
                             anguck();
                             return;
                           }

  if (match("#",&Cpt))     { i = 0;
                             while(i<8)
                             { c = ' ';
                               if (*Cpt) c = *Cpt++;
                               HT_Ram[i] = HT_Segments(c);
                               ++i;
                             }
                             HT_Transfer();
                             return;
                           }


  if (match("+",&Cpt))     { aseg = (aseg+1) & 15;
                             blinzel();
                             return;
                           }

  if (match("-",&Cpt))     { aseg = (aseg-1);
                             if (aseg<0) aseg = 15;
                             blinzel();
                             return;
                           }

  if (match("*",&Cpt))     { Buchstaben[abuch] = Buchstaben[abuch] ^ (1<<aseg);
                             anguck();
                             return;
                           }

  if (match("N+",&Cpt))    { abuch = abuch + 1;
                             if (abuch > 127) abuch = 0;
                             aseg = 0;
                             anguck();
                             String_Out("Buchstabe 0x", wo);
                             HexB_Out(abuch, wo);
                             CRLF_Out(wo);
                             return;
                           }

  if (match("N-",&Cpt))    { abuch = abuch - 1;
                             if (abuch < 0) abuch = 127;
                             aseg = 0;
                             anguck();
                             String_Out("Buchstabe 0x", wo);
                             HexB_Out(abuch, wo);
                             CRLF_Out(wo);
                             return;
                           }

  if (match("N",&Cpt))     { if (!*Cpt) return;
                             c = *Cpt;
                             abuch = c;
                             aseg = 0;
                             anguck();
                             String_Out("Buchstabe 0x", wo);
                             HexB_Out(abuch, wo);
                             CRLF_Out(wo);
                             return;
                           }

  if (match("L",&Cpt))     { i = 0;
                             while(i<128)
                             { if (Buchstaben[i])
                               { String_Out("  /* ", wo);
                                 HexB_Out(i, wo);
                                 Char_Out(' ', wo);
                                 if ((i>' ')&&(i<0x7F))
                                   Char_Out(i, wo);
                                 else
                                     Char_Out(' ', wo);
                                 String_Out(" */ 0x", wo);
                                 HexW_Out(Buchstaben[i], wo);
                                 String_Out(",\r\n", wo);
                               }
                               i++;
                             }
                             return;
                           }


  if (match("HL",&Cpt))    { Init_Holtek();
                             HT_Fill(0);
                             HT_Transfer();
                             return; }

  if (match("HH",&Cpt))    { Init_Holtek();
                             HT_Fill(0xFFFF);
                             HT_Transfer();
                             return; }

  if (match("H",&Cpt))     { L = Long_In(&Cpt);
                             if (!L) L = 25;
                             HT_Fill(0);
                             HT_Transfer();
                             Warte_ms(300);
                             i = 0;
                             while(i<128)
                             { //HT_Fill(0);
                               HT_Setze(i, 1);
                               HT_Transfer();
                               Warte_ms(L);
                               ++i;
                             }
                             String_Out("..fertig\r\n", wo);
                             return;
                           }



  if (match("T1L",&Cpt))   { TP1_L(); return; }
  if (match("T1H",&Cpt))   { TP1_H(); return; }
  if (match("T2L",&Cpt))   { TP2_L(); return; }
  if (match("T2H",&Cpt))   { TP2_H(); return; }

  if (match("T4L",&Cpt))   { TP4_L(); return; }
  if (match("T4H",&Cpt))   { TP4_H(); return; }
  if (match("T5L",&Cpt))   { TP5_L(); return; }
  if (match("T5H",&Cpt))   { TP5_H(); return; }

  if (match("IRMAX",&Cpt)){ StdIO = wo;
                            IrMax = Long_In(&Cpt);
                            return; }
  if (match("IRSCHWELLE",&Cpt)){ StdIO = wo;
                                 IrSchwelle = Long_In(&Cpt);
                                 return; }
  if (match("IRNUM",&Cpt)){ StdIO = wo;
                            IrNums = Long_In(&Cpt) != 0;
                            return; }
  if (match("IR",&Cpt))   { EnIR = true; return; }
  if (match("IR-",&Cpt))  { EnIR = false; return; }


  if (match("UTEST",&Cpt)){ L =  Long_In(&Cpt);
                            while (L)
                            { if (RxAvail(toUSB))
                              { c = GetChar(toUSB);
                                Char_Out(c, toUSB);
                                --L;
                              }
                            }
                            String_Out("\r\nSodele, das war es dann\r\n", toUSB);
                            return;
                          }


  if (!*Cpt) return;
  String_Out("wat? ", wo);
  while (*Cpt)
  { c = *Cpt;
    if (c < ' ')
    { Char_Out('^',wo);
      c = c + 0x40;
    }
    Char_Out(c, wo);
    ++Cpt;
  }
  CRLF_Out(wo);
}




/*************************************************************************/

int kzi;

void InitCmd (word wo)
{  long L;

   L = sizeof(Kommandozeile);
   while (L) Kommandozeile[--L] = 0;
   kzi = L;
   Char_Out('>', wo);
}

  /* Kommandozeile hereinholen */
void Talk (word wo)
{ char c;

  if (RxAvail(wo))
  { c =  GetChar(wo);
    StdIO = wo;
    if (c==10) return;
    if (c==13)
    { CRLF_Out(wo);
      DoCommand (Kommandozeile, wo);
      InitCmd(wo);
    }
    else
    { if (kzi>=(sizeof(Kommandozeile)-1)) return;
      if (c==8)
      { Char_Out(8, wo);
        Char_Out(' ', wo);
        Char_Out(8, wo);
        if (kzi) --kzi;
        Kommandozeile[kzi]=0;
      }
      else
      { if (c<' ')
        { Char_Out('^', wo);
          Char_Out(c+0x40, wo);
          Kommandozeile[kzi++] = c;
          Kommandozeile[kzi] = 0;
	  return;
        }
        Char_Out(c, wo);
        Kommandozeile[kzi++] = c;
        Kommandozeile[kzi] = 0;
      }
    }
  }
}


  /* ende */
